searchData={"items":[{"type":"module","title":"Surrealix","doc":"Main entry module for Surrealix","ref":"Surrealix.html"},{"type":"function","title":"Surrealix.all_live_queries/1","doc":"","ref":"Surrealix.html#all_live_queries/1"},{"type":"function","title":"Surrealix.authenticate/2","doc":"authenticate [ token ]\n  This method allows you to authenticate a user against SurrealDB with a token\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"authenticate\",\n      \"params\": [\n        \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#authenticate/2"},{"type":"function","title":"Surrealix.authenticate/3","doc":"","ref":"Surrealix.html#authenticate/3"},{"type":"function","title":"Surrealix.create/3","doc":"create [ thing, data ]\n  This method creates a record either with a random or specified ID\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"create\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.html#create/3"},{"type":"function","title":"Surrealix.create/4","doc":"","ref":"Surrealix.html#create/4"},{"type":"function","title":"Surrealix.delete/2","doc":"delete [ thing ]\n  This method deletes either all records in a table or a single record\n  NOTE: Notice how the deleted record is being returned here\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"delete\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"active\": true,\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"last_updated\": \"2023-06-16T08:34:25Z\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.html#delete/2"},{"type":"function","title":"Surrealix.delete/3","doc":"","ref":"Surrealix.html#delete/3"},{"type":"function","title":"Surrealix.info/1","doc":"info\n  This method returns the record of an authenticated scope user.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"info\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"user:john\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.html#info/1"},{"type":"function","title":"Surrealix.insert/3","doc":"insert [ thing, data ]\n  This method creates a record either with a random or specified ID\n  Single insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n  Bulk insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"name\": \"Mary Doe\"\n          },\n          {\n            \"name\": \"John Doe\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        },\n        {\n          \"id\": \"person:xtbbojcm82a97vus9x0j\",\n          \"name\": \"John Doe\"\n        }\n      ]\n    }","ref":"Surrealix.html#insert/3"},{"type":"function","title":"Surrealix.insert/4","doc":"","ref":"Surrealix.html#insert/4"},{"type":"function","title":"Surrealix.invalidate/1","doc":"invalidate\n  This method will invalidate the user's session for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"invalidate\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#invalidate/1"},{"type":"function","title":"Surrealix.kill/2","doc":"kill [ queryUuid ]\n  This methods kills an active live query\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"kill\",\n      \"params\": [\n        \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#kill/2"},{"type":"function","title":"Surrealix.kill/3","doc":"","ref":"Surrealix.html#kill/3"},{"type":"function","title":"Surrealix.let/3","doc":"let [ name, value ]\n  This method stores a variable on the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"let\",\n      \"params\": [\n        \"website\",\n        \"https://surrealdb.com/\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#let/3"},{"type":"function","title":"Surrealix.let/4","doc":"","ref":"Surrealix.html#let/4"},{"type":"function","title":"Surrealix.live/3","doc":"live [ table ]\n  This methods initiates a live query for a specified table name\n  NOTE: For more advanced live queries where filters are needed, use the Query method to initiate a custom live query.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"live\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n    }\n  Live notification\n\n  Example request:\n    {}\n\n  Example response:\n    {\n      \"result\": {\n        \"action\": \"CREATE\",\n        \"id\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\",\n        \"result\": {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      }\n    }","ref":"Surrealix.html#live/3"},{"type":"function","title":"Surrealix.live/4","doc":"","ref":"Surrealix.html#live/4"},{"type":"function","title":"Surrealix.live_query/4","doc":"Convenience method, that combines sending an query (live_query) and registering a callback\n\nParams:\n  sql: string\n  vars: map with variables to interpolate into SQL\n  callback: fn (event, data, config)","ref":"Surrealix.html#live_query/4"},{"type":"function","title":"Surrealix.merge/3","doc":"merge [ thing, data ]\n  This method merges specified data into either all records in a table or a single record\n  NOTE: This function merges the current document / record data with the specified data. If no merge data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"merge\",\n      \"params\": [\n        \"person\",\n        {\n          \"active\": true\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"active\": true,\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John Doe\"\n        },\n        {\n          \"active\": true,\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.html#merge/3"},{"type":"function","title":"Surrealix.merge/4","doc":"","ref":"Surrealix.html#merge/4"},{"type":"function","title":"Surrealix.patch/4","doc":"patch [ thing, patches, diff ]\n  This method patches either all records in a table or a single record with specified patches\n  NOTE: This function patches the current document / record data with the specified JSON Patch data.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"patch\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"op\": \"replace\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ],\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }","ref":"Surrealix.html#patch/4"},{"type":"function","title":"Surrealix.patch/5","doc":"","ref":"Surrealix.html#patch/5"},{"type":"function","title":"Surrealix.ping/1","doc":"ping\n  This method pings the SurrealDB instance\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"ping\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#ping/1"},{"type":"function","title":"Surrealix.query/3","doc":"query [ sql, vars ]\n  This method executes a custom query against SurrealDB\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"query\",\n      \"params\": [\n        \"CREATE person SET name = 'John'; SELECT * FROM type::table($tb);\",\n        {\n          \"tb\": \"person\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"status\": \"OK\",\n          \"time\": \"152.5µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        },\n        {\n          \"status\": \"OK\",\n          \"time\": \"32.375µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        }\n      ]\n    }","ref":"Surrealix.html#query/3"},{"type":"function","title":"Surrealix.query/4","doc":"","ref":"Surrealix.html#query/4"},{"type":"function","title":"Surrealix.reset_live_queries/1","doc":"","ref":"Surrealix.html#reset_live_queries/1"},{"type":"function","title":"Surrealix.select/2","doc":"select [ thing ]\n  This method selects either all records in a table or a single record\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"select\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      ]\n    }","ref":"Surrealix.html#select/2"},{"type":"function","title":"Surrealix.select/3","doc":"","ref":"Surrealix.html#select/3"},{"type":"function","title":"Surrealix.set_auth_ready/2","doc":"","ref":"Surrealix.html#set_auth_ready/2"},{"type":"function","title":"Surrealix.signin/2","doc":"signin [ NS, DB, SC, ... ]\n  This method allows you to signin a root, NS, DB or SC user against SurrealDB\n  As Root\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"user\": \"tobie\",\n          \"pass\": \"3xtr3m3ly-s3cur3-p@ssw0rd\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }\n  Signin as scope\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.html#signin/2"},{"type":"function","title":"Surrealix.signin/3","doc":"","ref":"Surrealix.html#signin/3"},{"type":"function","title":"Surrealix.signup/2","doc":"signup [ NS, DB, SC, ... ]\n  This method allows you to signup a user against a scope's SIGNUP method\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signup\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.html#signup/2"},{"type":"function","title":"Surrealix.signup/3","doc":"","ref":"Surrealix.html#signup/3"},{"type":"function","title":"Surrealix.start/1","doc":"","ref":"Surrealix.html#start/1"},{"type":"function","title":"Surrealix.start_link/1","doc":"","ref":"Surrealix.html#start_link/1"},{"type":"function","title":"Surrealix.stop/1","doc":"","ref":"Surrealix.html#stop/1"},{"type":"function","title":"Surrealix.unset/2","doc":"unset [ name ]\n  This method removes a variable from the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"unset\",\n      \"params\": [\n        \"website\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#unset/2"},{"type":"function","title":"Surrealix.unset/3","doc":"","ref":"Surrealix.html#unset/3"},{"type":"function","title":"Surrealix.update/3","doc":"update [ thing, data ]\n  This method replaces either all records in a table or a single record with specified data\n  NOTE: This function replaces the current document / record data with the specified data. If no replacement data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"update\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\",\n        {\n          \"name\": \"John Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.html#update/3"},{"type":"function","title":"Surrealix.update/4","doc":"","ref":"Surrealix.html#update/4"},{"type":"function","title":"Surrealix.use/3","doc":"use [ ns, db ]\n  Specifies the namespace and database for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"use\",\n      \"params\": [\n        \"surrealdb\",\n        \"docs\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.html#use/3"},{"type":"function","title":"Surrealix.use/4","doc":"","ref":"Surrealix.html#use/4"},{"type":"function","title":"Surrealix.wait_until_auth_ready/1","doc":"","ref":"Surrealix.html#wait_until_auth_ready/1"},{"type":"module","title":"Surrealix.Accessible","doc":"A vendored package, that makes reaching into deep structs little bit nicer.","ref":"Surrealix.Accessible.html"},{"type":"module","title":"Surrealix.Api","doc":"Thin layer over the Websockets API for SurrealDB that is 100% generated from a data-structure.","ref":"Surrealix.Api.html"},{"type":"function","title":"Surrealix.Api.authenticate/3","doc":"authenticate [ token ]\n  This method allows you to authenticate a user against SurrealDB with a token\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"authenticate\",\n      \"params\": [\n        \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#authenticate/3"},{"type":"function","title":"Surrealix.Api.build_cast_payload/3","doc":"","ref":"Surrealix.Api.html#build_cast_payload/3"},{"type":"function","title":"Surrealix.Api.create/4","doc":"create [ thing, data ]\n  This method creates a record either with a random or specified ID\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"create\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#create/4"},{"type":"function","title":"Surrealix.Api.delete/3","doc":"delete [ thing ]\n  This method deletes either all records in a table or a single record\n  NOTE: Notice how the deleted record is being returned here\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"delete\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"active\": true,\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"last_updated\": \"2023-06-16T08:34:25Z\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.Api.html#delete/3"},{"type":"function","title":"Surrealix.Api.info/2","doc":"info\n  This method returns the record of an authenticated scope user.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"info\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"user:john\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.Api.html#info/2"},{"type":"function","title":"Surrealix.Api.insert/4","doc":"insert [ thing, data ]\n  This method creates a record either with a random or specified ID\n  Single insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        {\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }\n  Bulk insert\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"insert\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"name\": \"Mary Doe\"\n          },\n          {\n            \"name\": \"John Doe\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        },\n        {\n          \"id\": \"person:xtbbojcm82a97vus9x0j\",\n          \"name\": \"John Doe\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#insert/4"},{"type":"function","title":"Surrealix.Api.invalidate/2","doc":"invalidate\n  This method will invalidate the user's session for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"invalidate\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#invalidate/2"},{"type":"function","title":"Surrealix.Api.kill/3","doc":"kill [ queryUuid ]\n  This methods kills an active live query\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"kill\",\n      \"params\": [\n        \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#kill/3"},{"type":"function","title":"Surrealix.Api.let/4","doc":"let [ name, value ]\n  This method stores a variable on the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"let\",\n      \"params\": [\n        \"website\",\n        \"https://surrealdb.com/\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#let/4"},{"type":"function","title":"Surrealix.Api.live/4","doc":"live [ table ]\n  This methods initiates a live query for a specified table name\n  NOTE: For more advanced live queries where filters are needed, use the Query method to initiate a custom live query.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"live\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\"\n    }\n  Live notification\n\n  Example request:\n    {}\n\n  Example response:\n    {\n      \"result\": {\n        \"action\": \"CREATE\",\n        \"id\": \"0189d6e3-8eac-703a-9a48-d9faa78b44b9\",\n        \"result\": {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      }\n    }","ref":"Surrealix.Api.html#live/4"},{"type":"function","title":"Surrealix.Api.live_query/4","doc":"Convenience method that combines sending a (live-)query and registering a callback.\n\nParams:\n    sql: string\n    vars: map with variables to interpolate into SQL\n    callback: fn (data, live_query_id)","ref":"Surrealix.Api.html#live_query/4"},{"type":"function","title":"Surrealix.Api.merge/4","doc":"merge [ thing, data ]\n  This method merges specified data into either all records in a table or a single record\n  NOTE: This function merges the current document / record data with the specified data. If no merge data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"merge\",\n      \"params\": [\n        \"person\",\n        {\n          \"active\": true\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"active\": true,\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John Doe\"\n        },\n        {\n          \"active\": true,\n          \"id\": \"person:s5fa6qp4p8ey9k5j0m9z\",\n          \"name\": \"Mary Doe\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#merge/4"},{"type":"function","title":"Surrealix.Api.patch/5","doc":"patch [ thing, patches, diff ]\n  This method patches either all records in a table or a single record with specified patches\n  NOTE: This function patches the current document / record data with the specified JSON Patch data.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"patch\",\n      \"params\": [\n        \"person\",\n        [\n          {\n            \"op\": \"replace\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ],\n        [\n          {\n            \"op\": \"add\",\n            \"path\": \"/last_updated\",\n            \"value\": \"2023-06-16T08:34:25Z\"\n          }\n        ]\n      ]\n    }","ref":"Surrealix.Api.html#patch/5"},{"type":"function","title":"Surrealix.Api.ping/2","doc":"ping\n  This method pings the SurrealDB instance\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"ping\"\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#ping/2"},{"type":"function","title":"Surrealix.Api.query/4","doc":"query [ sql, vars ]\n  This method executes a custom query against SurrealDB\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"query\",\n      \"params\": [\n        \"CREATE person SET name = 'John'; SELECT * FROM type::table($tb);\",\n        {\n          \"tb\": \"person\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"status\": \"OK\",\n          \"time\": \"152.5µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        },\n        {\n          \"status\": \"OK\",\n          \"time\": \"32.375µs\",\n          \"result\": [\n            {\n              \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n              \"name\": \"John\"\n            }\n          ]\n        }\n      ]\n    }","ref":"Surrealix.Api.html#query/4"},{"type":"function","title":"Surrealix.Api.select/3","doc":"select [ thing ]\n  This method selects either all records in a table or a single record\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"select\",\n      \"params\": [\n        \"person\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": [\n        {\n          \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n          \"name\": \"John\"\n        }\n      ]\n    }","ref":"Surrealix.Api.html#select/3"},{"type":"function","title":"Surrealix.Api.signin/3","doc":"signin [ NS, DB, SC, ... ]\n  This method allows you to signin a root, NS, DB or SC user against SurrealDB\n  As Root\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"user\": \"tobie\",\n          \"pass\": \"3xtr3m3ly-s3cur3-p@ssw0rd\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }\n  Signin as scope\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signin\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.Api.html#signin/3"},{"type":"function","title":"Surrealix.Api.signup/3","doc":"signup [ NS, DB, SC, ... ]\n  This method allows you to signup a user against a scope's SIGNUP method\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"signup\",\n      \"params\": [\n        {\n          \"NS\": \"surrealdb\",\n          \"DB\": \"docs\",\n          \"SC\": \"commenter\",\n          \"username\": \"johndoe\",\n          \"password\": \"SuperStrongPassword!\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": \"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJTdXJyZWFsREIiLCJpYXQiOjE1MTYyMzkwMjIsIm5iZiI6MTUxNjIzOTAyMiwiZXhwIjoxODM2NDM5MDIyLCJOUyI6InRlc3QiLCJEQiI6InRlc3QiLCJTQyI6InVzZXIiLCJJRCI6InVzZXI6dG9iaWUifQ.N22Gp9ze0rdR06McGj1G-h2vu6a6n9IVqUbMFJlOxxA\"\n    }","ref":"Surrealix.Api.html#signup/3"},{"type":"function","title":"Surrealix.Api.unset/3","doc":"unset [ name ]\n  This method removes a variable from the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"unset\",\n      \"params\": [\n        \"website\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#unset/3"},{"type":"function","title":"Surrealix.Api.update/4","doc":"update [ thing, data ]\n  This method replaces either all records in a table or a single record with specified data\n  NOTE: This function replaces the current document / record data with the specified data. If no replacement data is passed it will simply trigger an update.\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"update\",\n      \"params\": [\n        \"person:8s0j0bbm3ngrd5c9bx53\",\n        {\n          \"name\": \"John Doe\"\n        }\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": {\n        \"id\": \"person:8s0j0bbm3ngrd5c9bx53\",\n        \"name\": \"John Doe\"\n      }\n    }","ref":"Surrealix.Api.html#update/4"},{"type":"function","title":"Surrealix.Api.use/4","doc":"use [ ns, db ]\n  Specifies the namespace and database for the current connection\n\n  Example request:\n    {\n      \"id\": 1,\n      \"method\": \"use\",\n      \"params\": [\n        \"surrealdb\",\n        \"docs\"\n      ]\n    }\n\n  Example response:\n    {\n      \"id\": 1,\n      \"result\": null\n    }","ref":"Surrealix.Api.html#use/4"},{"type":"module","title":"Surrealix.Config","doc":"Explicit config module to keep configurable options in a single place","ref":"Surrealix.Config.html"},{"type":"function","title":"Surrealix.Config.backoff_max/0","doc":"","ref":"Surrealix.Config.html#backoff_max/0"},{"type":"function","title":"Surrealix.Config.backoff_step/0","doc":"","ref":"Surrealix.Config.html#backoff_step/0"},{"type":"function","title":"Surrealix.Config.base_conn_opts/0","doc":"","ref":"Surrealix.Config.html#base_conn_opts/0"},{"type":"function","title":"Surrealix.Config.default_timeout/0","doc":"","ref":"Surrealix.Config.html#default_timeout/0"},{"type":"function","title":"Surrealix.Config.json/0","doc":"","ref":"Surrealix.Config.html#json/0"},{"type":"function","title":"Surrealix.Config.task_opts_default/0","doc":"","ref":"Surrealix.Config.html#task_opts_default/0"},{"type":"type","title":"Surrealix.Config.base_connection_opts/0","doc":"","ref":"Surrealix.Config.html#t:base_connection_opts/0"},{"type":"type","title":"Surrealix.Config.socket_opts/0","doc":"","ref":"Surrealix.Config.html#t:socket_opts/0"},{"type":"module","title":"Surrealix.RescueProcess","doc":"This module is responsible to execute callbacks for on_auth hooks, that happen after a connection is established.\nThis can not be done direcly in the `handle_connect` callback, since then it blocks the execution of the WebSockex process.\n\nTo workaround this issue, we delegate this responsibility to a `RescueProcess`, that executes those callbacks out-of-band.\nAlso we need to use `GenServer.cast`, so that the Socket can properly continue and not be deadlocked.","ref":"Surrealix.RescueProcess.html"},{"type":"function","title":"Surrealix.RescueProcess.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Surrealix.RescueProcess.html#child_spec/1"},{"type":"function","title":"Surrealix.RescueProcess.execute_callback/1","doc":"","ref":"Surrealix.RescueProcess.html#execute_callback/1"},{"type":"function","title":"Surrealix.RescueProcess.start_link/1","doc":"","ref":"Surrealix.RescueProcess.html#start_link/1"},{"type":"module","title":"Surrealix.Sandbox","doc":"A small module to quickly test reconnection logic during development","ref":"Surrealix.Sandbox.html"},{"type":"function","title":"Surrealix.Sandbox.run/0","doc":"","ref":"Surrealix.Sandbox.html#run/0"},{"type":"module","title":"Surrealix.Socket","doc":"Socket module to wrap the interactions with `WebSockex` process.","ref":"Surrealix.Socket.html"},{"type":"function","title":"Surrealix.Socket.all_live_queries/1","doc":"Show all currently registered live queries (SQL)","ref":"Surrealix.Socket.html#all_live_queries/1"},{"type":"function","title":"Surrealix.Socket.exec_method/2","doc":"Main method to send requests in blocking fashion to SurrealDB","ref":"Surrealix.Socket.html#exec_method/2"},{"type":"function","title":"Surrealix.Socket.reset_live_queries/1","doc":"Reset `running` live queries status, used after reconnection","ref":"Surrealix.Socket.html#reset_live_queries/1"},{"type":"function","title":"Surrealix.Socket.set_auth_ready/2","doc":"Switch for `auth_ready` boolean flag","ref":"Surrealix.Socket.html#set_auth_ready/2"},{"type":"function","title":"Surrealix.Socket.start/1","doc":"","ref":"Surrealix.Socket.html#start/1"},{"type":"function","title":"Surrealix.Socket.start_link/1","doc":"","ref":"Surrealix.Socket.html#start_link/1"},{"type":"function","title":"Surrealix.Socket.stop/1","doc":"","ref":"Surrealix.Socket.html#stop/1"},{"type":"function","title":"Surrealix.Socket.wait_until_auth_ready/1","doc":"Busy-wait until the `on_auth` callback is executed","ref":"Surrealix.Socket.html#wait_until_auth_ready/1"},{"type":"type","title":"Surrealix.Socket.base_connection_opts/0","doc":"","ref":"Surrealix.Socket.html#t:base_connection_opts/0"},{"type":"type","title":"Surrealix.Socket.on_start/0","doc":"","ref":"Surrealix.Socket.html#t:on_start/0"},{"type":"module","title":"Surrealix.SocketState","doc":"SocketState module makes testing the State transitions for Socket much simpler","ref":"Surrealix.SocketState.html"},{"type":"function","title":"Surrealix.SocketState.__struct__/0","doc":"- `pending`: Pending requests map:  id => task\n  - `lq_running`: live_queries map:  id => %{sql: sql}\n  - `lq_sql`: live_queries MapSet with queries to register after re-connection","ref":"Surrealix.SocketState.html#__struct__/0"},{"type":"function","title":"Surrealix.SocketState.all_live_queries/1","doc":"Currently registered LiveQueries","ref":"Surrealix.SocketState.html#all_live_queries/1"},{"type":"function","title":"Surrealix.SocketState.delete/2","doc":"","ref":"Surrealix.SocketState.html#delete/2"},{"type":"function","title":"Surrealix.SocketState.delete_live_query_by_id/2","doc":"Remove a LiveQuery by ID","ref":"Surrealix.SocketState.html#delete_live_query_by_id/2"},{"type":"function","title":"Surrealix.SocketState.delete_live_query_by_sql/2","doc":"Remove a LiveQuery by SQL","ref":"Surrealix.SocketState.html#delete_live_query_by_sql/2"},{"type":"function","title":"Surrealix.SocketState.delete_task/2","doc":"Remove a task for a particular request ID","ref":"Surrealix.SocketState.html#delete_task/2"},{"type":"function","title":"Surrealix.SocketState.get/3","doc":"","ref":"Surrealix.SocketState.html#get/3"},{"type":"function","title":"Surrealix.SocketState.get_live_query/2","doc":"Get map that describes a particular LiveQuery ID (SQL / ID / etc)","ref":"Surrealix.SocketState.html#get_live_query/2"},{"type":"function","title":"Surrealix.SocketState.get_task/2","doc":"Get a task for a particular request ID","ref":"Surrealix.SocketState.html#get_task/2"},{"type":"function","title":"Surrealix.SocketState.is_auth_ready/1","doc":"","ref":"Surrealix.SocketState.html#is_auth_ready/1"},{"type":"function","title":"Surrealix.SocketState.new/0","doc":"","ref":"Surrealix.SocketState.html#new/0"},{"type":"function","title":"Surrealix.SocketState.new/1","doc":"","ref":"Surrealix.SocketState.html#new/1"},{"type":"function","title":"Surrealix.SocketState.put/3","doc":"","ref":"Surrealix.SocketState.html#put/3"},{"type":"function","title":"Surrealix.SocketState.register_live_query/4","doc":"Register a SQL statement for a particular LiveQuery ID","ref":"Surrealix.SocketState.html#register_live_query/4"},{"type":"function","title":"Surrealix.SocketState.register_task/3","doc":"Register a task for a particular request ID","ref":"Surrealix.SocketState.html#register_task/3"},{"type":"function","title":"Surrealix.SocketState.reset_live_queries/1","doc":"","ref":"Surrealix.SocketState.html#reset_live_queries/1"},{"type":"function","title":"Surrealix.SocketState.set_auth_ready/2","doc":"","ref":"Surrealix.SocketState.html#set_auth_ready/2"},{"type":"module","title":"Surrealix.Telemetry","doc":"Provides conventions to publishing `:telemetry` events","ref":"Surrealix.Telemetry.html"},{"type":"module","title":"Surrealix.Telemetry.Logger","doc":"Telemetry Logger. Hooks telemetry events and logs them to stdout.","ref":"Surrealix.Telemetry.Logger.html"},{"type":"function","title":"Surrealix.Telemetry.Logger.handle_event/4","doc":"","ref":"Surrealix.Telemetry.Logger.html#handle_event/4"},{"type":"function","title":"Surrealix.Telemetry.Logger.setup/0","doc":"","ref":"Surrealix.Telemetry.Logger.html#setup/0"},{"type":"module","title":"Surrealix.Util","doc":"Generic utility functions","ref":"Surrealix.Util.html"},{"type":"function","title":"Surrealix.Util.is_live_query_stmt/1","doc":"A basic check to make sure the SQL statement is indeed a live query.\nProper check would require parsing the SQL statement and is outside of scope for this library.","ref":"Surrealix.Util.html#is_live_query_stmt/1"},{"type":"function","title":"Surrealix.Util.uuid/1","doc":"A small random string generator","ref":"Surrealix.Util.html#uuid/1"},{"type":"exception","title":"Surrealix.Patiently.GaveUp","doc":"Exception raised by Patiently when a condition fails to converge","ref":"Surrealix.Patiently.GaveUp.html"},{"type":"type","title":"Surrealix.Patiently.GaveUp.t/0","doc":"","ref":"Surrealix.Patiently.GaveUp.html#t:t/0"}],"content_type":"text/markdown"}